<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\SystemPhysicRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\SystemPhysic;
use App\Specialty;
use App\Physical;
use App\CodePhysic;
use App\CodePhyscal;

class SystemPhysicController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/systemphysics';
    /** View folder */
    private $viewDirectory= 'admin.systemphysics.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('systemphysics.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the systemphysics.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = SystemPhysic::orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $systemphysics= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('systemphysics'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('systemphysics.store');
        $head = metaFields('systemphysics', 'add_new', getCurrentLocale()) ?? __('systemphysics.new');
        $specialties = Specialty::all();
        $physics = Physical::cursor();
       

        return view( $this->viewDirectory.'form', compact('action', 'head','specialties','physics') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param SystemPhysicRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(SystemPhysicRequest $request) :RedirectResponse
    {
   
        $systemphysic= SystemPhysic::create($request->all());
      $this->saveData( $request, $systemphysic->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  SystemPhysic  $systemphysic
     * @return View
     */
    public function edit(SystemPhysic $systemphysic): View
    {
        $action= route('systemphysics.update', $systemphysic->id);
        $head = metaFields('systemphysics', 'edit', getCurrentLocale()) ?? __('systemphysics.edit');
        $specialties = Specialty::all();
        $physics = Physical::cursor();
        $codes = CodePhysic::where('system_physcal_id',$systemphysic->id)->get();


        return view( $this->viewDirectory.'form', compact('systemphysic', 'action', 'head','specialties','physics','codes') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  SystemPhysicRequest  $request
     * @param  SystemPhysic  $systemphysic
     * @return RedirectResponse|Redirector
     */
        public function update(SystemPhysicRequest $request, SystemPhysic $systemphysic) :RedirectResponse
    {
      
        $systemphysic->update($request->all());
        $ids = CodePhysic::where('system_physcal_id',$systemphysic->id)->pluck('id');
        CodePhysic::where('system_physcal_id',$systemphysic->id)->forceDelete();
        CodePhyscal::whereIn('code_id',$ids)->forceDelete();
	 $this->saveData( $request, $systemphysic->id );


        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    private function saveData(SystemPhysicRequest $request, int $systemphysic ) :void
     {

        $requestData= $request->all();
    if(!is_null($request->physical)){
        foreach ($request->physical as $row) {
            $data=[
                'system_physcal_id'=> $systemphysic,
                'name'=> $row['name'],
                
            ];

            $code = CodePhysic::create($data);
            $code->physicals()->attach($row['physics']);
        }
    }
     }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = SystemPhysic::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            SystemPhysic::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            SystemPhysic::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = SystemPhysic::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = SystemPhysic::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
